#!/usr/bin/env bash
echo;
echo "Artifact for the TACAS'20 tool demonstration paper:";
echo;
echo "FIG: the Finite Improbability Generator";
echo "                      by Carlos E. Budde";
echo;
echo "--[ Installing required deb packages ]--------";
cd dependencies;
./install_dependencies.sh;
cd ..;
echo "--[ Done ]------------------------------------";
echo;
echo "--[ Preparing fig ]---------------------------";
unzip fig.zip;
cd fig;
./build_fig.sh;
cd ..;
mv fig /home/tacas20ae;
/home/tacas20ae/fig/fig;
echo "--[ Done ]------------------------------------";
echo;
echo "--[ Preparing modes ]-------------------------";
unzip Modest-linux-x64.zip;
mv Modest /home/tacas20ae;
/home/tacas20ae/Modest/modest simulate -? | head -n 2;
echo "--[ Done ]------------------------------------";
echo;
echo "--[ Uncompressing experiments ]---------------";
unzip experiments.zip;
echo "--[ Done ]------------------------------------";
echo;
echo "-- To review the artifact, please execute:";
echo;
echo "cd ~/artifact/experiments/vs_theory; ./run.sh";
echo "cd ~/artifact/experiments/vs_big_models; ./run.sh";
echo "cd ~/artifact/experiments/vs_modes; ./run.py";
echo;
echo "-- Please wait for each experiment to end before starting the next one";
echo "-- Thank you for reviewing this artifact!";
echo;
exit 0;
